package org.ten60.demo.pvnp;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

public class PowerSet
{
	//Generate powerset
	public static List<ArrayList> powerset(ArrayList<Integer> a)
	{	boolean[] membership=new boolean[a.size()];
		LinkedList<ArrayList> ps=new LinkedList();
		for(int i=0; i<(Math.pow(2,a.size())-1);i++)
		{	int c=0;
			membership[0]=!membership[0];
			boolean carry=!membership[0];
			while(c+1<a.size())
			{	c++;
				if(carry)
				{	membership[c]=!membership[c];
					carry=!membership[c];
				}
				else break;
			}
			ArrayList vec=new ArrayList();
			for(int j=0;j<a.size();j++)
			{	if(membership[j])
				{   vec.add(a.get(j));
				}
			}
			ps.add(vec);
		}
		return ps;
	}

	//A powerset that terminates if it finds the subset sum target
	public static int fastpowerset(ArrayList<Integer> a, int target)
	{	int size=a.size();
		boolean[] membership=new boolean[size];
		for(int i=0; i<(Math.pow(2,size)-1);i++)
		{	int c=0;
			membership[0]=!membership[0];
			boolean carry=!membership[0];
			while(c+1<size)
			{	c++;
				if(carry)
				{	membership[c]=!membership[c];
					carry=!membership[c];
				}
				else break;
			}
			int sm=0;
			for(int j=0;j<size;j++)
			{	if(membership[j])
				{   sm+=a.get(j);
					if(sm>=target)
					{
						if(sm==target)
						{	return sm;						
						}
						if(sm>target)
						{	break;						
						}
					}
				}
			}
		}
		return -1;
	}

}
